PRO LDRS_ALGOLIST_SELECT, Event
COMMON ldrs, env
m = env.recipe->GetSelectedModule()
IF NOT OBJ_VALID(m) THEN RETURN
selNr = Event.index
algo = m->GetAlgorithm(selNr)
env.recipe->SelectAlgorithm, algo
IF Event.clicks EQ 2 THEN LDRS_ALGO_EDIT, Event
END

FUNCTION ldrsALGOLIST::Init, cfg, frame
IF NOT self->ldrsVIEW::Init(cfg, frame) THEN RETURN, 0

RETURN, 1
END

PRO ldrsALGOLIST::ModuleSelected, module
COMMON ldrs, env
nAlgos = module->GetNAlgorithms()
IF nAlgos EQ 0 THEN BEGIN
    WIDGET_CONTROL, self.guiPanel, SET_VALUE='<EMPTY>', SENSITIVE=0
    self->DisableButtons
    RETURN
END
arr = STRARR(nAlgos)
selAlgo = -1
FOR i = 0, nAlgos - 1 DO BEGIN
    algo = module->GetAlgorithm(i)
    IF algo EQ module->GetSelectedAlgorithm() THEN selAlgo = i
    arr[i] = algo->GetLabel()
ENDFOR
IF selAlgo EQ -1 THEN BEGIN
    WIDGET_CONTROL, self.guiPanel, SET_VALUE=arr, SENSITIVE=1
END ELSE BEGIN
    WIDGET_CONTROL, self.guiPanel, SET_VALUE=arr, SET_LIST_SELECT=selAlgo, SENSITIVE=1
END
self->EnableButtons
END

PRO ldrsALGOLIST::ModuleDeselected, module
COMMON ldrs, env
WIDGET_CONTROL, self.guiPanel, SET_VALUE='<EMPTY>', SENSITIVE=0
self->DisableButtons
END

PRO ldrsALGOLIST::CreateContent, cfgPanel
;PRINT, 'ldrsALGOLIST::CreateContent called'
self.guiPanel = WIDGET_LIST(self.guiBase, SENSITIVE=0, UNITS=0, $
                            SCR_XSIZE=self.scrSize[0], SCR_YSIZE=self.scrSize[1], $
                            EVENT_PRO='LDRS_ALGOLIST_SELECT')
END

PRO ldrsALGOLIST__define
  struct = { ldrsALGOLIST, $
             INHERITS ldrsVIEW $
           }
END
