FUNCTION ldrsIMGOBJ::Init, tool, nr, font
IF NOT self->IDLgrModel::Init(/SELECT_TARGET) THEN RETURN, 0
self.otool = tool
self.labelNr = nr
self.label = STRING(FORMAT='(A, I0)', self.labelPrefix, self.labelNr)
self.font = font
self.col = [0, 255, 0]
RETURN, 1
END

FUNCTION ldrsIMGOBJ::GetLabel
RETURN, self.label
END

PRO ldrsIMGOBJ::SetLabel, PREFIX=prefix, NR=nr
IF N_ELEMENTS(prefix) NE 0 THEN self.labelPrefix = prefix
IF N_ELEMENTS(nr) NE 0 THEN self.labelNr = nr
self.label = STRING(FORMAT='(A, I0)', self.labelPrefix, self.labelNr)
END

FUNCTION ldrsIMGOBJ::GetNr
RETURN, self.labelNr
END

PRO ldrsIMGOBJ::Move, dx, dy
END

PRO ldrsIMGOBJ::SetPosition, x, y
END

PRO ldrsIMGOBJ::Enlarge
END

PRO ldrsIMGOBJ::Shrink
END

PRO ldrsIMGOBJ::ChangeColor, col
END

PRO ldrsIMGOBJ::Select
IF NOT self.selected THEN BEGIN
    self.selected = 1
    self->ChangeColor, [255, 0, 255]
ENDIF
END

PRO ldrsIMGOBJ::Deselect
IF self.selected THEN BEGIN
    self.selected = 0
    self->ChangeColor, self.col
ENDIF
END

PRO ldrsIMGOBJ::Store, cfg
END

PRO ldrsIMGOBJ::Load, cfg
END

PRO ldrsIMGOBJ::Edit, top
IF NOT OBJ_VALID(self.otool) THEN RETURN
self.otool->Edit, top, self
END

PRO ldrsIMGOBJ__define
  struct = { ldrsIMGOBJ, $
             INHERITS IDLgrModel, $
             otool:OBJ_NEW(), $
             nr:0, $
             font:OBJ_NEW(), $
             col:[0, 255, 0], $
             selected:0, $
             labelPrefix:'', $
             labelNr:0, $
             label:'' $
           }
END
