PRO LDRS_ENV, CFG=cfg, FORCE=force, RECIPE=recipe
COMMON ldrs, env
; create the structure of the ldrs environment if neccessary
myapp_info = ROUTINE_INFO('LDRS_ENV', /SOURCE)  
myapp_path = FILE_DIRNAME(myapp_info.path)  
IF N_ELEMENTS(env) EQ 0 THEN BEGIN
    env = {ldrs, $
           config:OBJ_NEW(), $
           recipe:OBJ_NEW(), $
           using_gui:0, $
           nFrames:0, $
           frames:OBJARR(10), $
           toplevels:PTR_NEW(), $
           log:OBJ_NEW(), $
           logFile:0 $
          }
    env.config = OBJ_NEW('ldrsCFG', OBJ_NEW(), '', -1)
    env.using_gui = 0
    myapp_help_path = myapp_path + PATH_SEP() + 'help'  
    !HELP_PATH = !HELP_PATH + PATH_SEP(/SEARCH_PATH) + myapp_help_path
    !EXCEPT = 2
ENDIF
IF NOT KEYWORD_SET(force) THEN force = 0
IF (env.config->GetNChilds() EQ 0) OR force THEN BEGIN
    ;loading the global configuration if necessary
    IF NOT KEYWORD_SET(cfg) THEN BEGIN
        cfg = myapp_path + PATH_SEP() + 'ldrs.cfg'
    ENDIF
    env.config = OBJ_NEW('ldrsCFG', OBJ_NEW(), '', -1)
    OPENR, lun, cfg, /GET_LUN
    env.config->Load, lun
    FREE_LUN, lun
    env.recipe = OBJ_NEW('ldrsRECIPE', env.config)
ENDIF
IF N_ELEMENTS(recipe) NE 0 THEN BEGIN
    env.recipe->Read, recipe
ENDIF
END
