FUNCTION ldrsINFOTOOL::Init, view
IF NOT self->ldrsVIEWTOOL::Init(view) THEN RETURN, 0
self.objClass = 'ldrsIMGOBJ'
RETURN, 1
END

PRO ldrsINFOTOOL::Select, x, y
needRedraw=0
; deselect any previously selected object
IF OBJ_VALID(self.selObj) THEN BEGIN
    self.selObj->Deselect
    self.selObj = OBJ_NEW()
    needRedraw=1
ENDIF
selObj = self.view->Select(x, y)
selSpec = SIZE(selObj)
;PRINT, 'mouse click detected at (', event.x, ',', event.y, ')'
IF selSpec[0] EQ 0 THEN BEGIN
    PRINT, '   no object selected'
    IF needRedraw THEN self.view->Redraw
    RETURN
END
FOR i=0, selSpec[1]-1 DO BEGIN
    IF OBJ_ISA(selObj[i], self.objClass) THEN BEGIN
        self.selObj = selObj[i]
        self.selObj->Select
        needRedraw=1
        BREAK
    ENDIF
END
IF needRedraw THEN self.view->Redraw
END

PRO ldrsINFOTOOL::PressMiddle, modifiers, x, y
IF modifiers EQ 1 THEN BEGIN
    self->ldrsVIEWTOOL::PressMiddle, modifiers, x, y
ENDIF
END

PRO ldrsINFOTOOL::Move, modifiers, x, y
IF modifiers EQ 1 THEN BEGIN
    self->ldrsVIEWTOOL::Move, modifiers, x, y
ENDIF
END

PRO ldrsINFOTOOL::ReleaseLeft, modifiers, x, y
IF modifiers EQ 1 THEN BEGIN
    self->ldrsVIEWTOOL::ReleaseLeft, modifiers, x, y
    RETURN
ENDIF
self->Select, x, y
IF NOT OBJ_VALID(self.selObj) THEN RETURN
self.view->Redraw
self.selObj->Edit, self.top
END

PRO ldrsINFOTOOL::ReleaseMiddle, modifiers, x, y
IF modifiers EQ 1 THEN BEGIN
    self->ldrsVIEWTOOL::ReleaseMiddle, modifiers, x, y
ENDIF
END

PRO ldrsINFOTOOL::ReleaseRight, modifiers, x, y
IF modifiers EQ 1 THEN BEGIN
    self->ldrsVIEWTOOL::ReleaseRight, modifiers, x, y
ENDIF
END

PRO ldrsINFOTOOL__define
struct = { ldrsINFOTOOL, $
           INHERITS ldrsVIEWTOOL, $
           objClass:'', $
           selObj:OBJ_NEW() $
         }
END
