FUNCTION ldrsPSFSTAR::Init, tool, nr, font
IF NOT self->ldrsIMGAREA::Init(tool, nr, font) THEN RETURN, 0
;PRINT, 'ldrsPSFSTAR::Init, col=', self.col
self.crossFlag = 1
self.labelFlag = 1
self.boxFlag = 1
self.mMode = 1 ; left == right, bottom == top => rectangular, centered
self.haloAlgo = 0
self.epolAlgo = 0
self.nxy = 0
RETURN, 1
END

PRO ldrsPSFSTAR::GetHalo, haloAlgo
haloAlgo = self.haloAlgo
END

PRO ldrsPSFSTAR::SetHalo, haloAlgo
self.haloAlgo = haloAlgo
END

PRO ldrsPSFSTAR::GetExtrapolation, epolAlgo
epolAlgo = self.epolAlgo
END

PRO ldrsPSFSTAR::SetExtrapolation, epolAlgo
self.epolAlgo = epolAlgo
END

PRO ldrsPSFSTAR::GetDimension, nxy
nxy = self.nxy
END

PRO ldrsPSFSTAR::SetDimension, nxy
self.nxy = nxy
END

PRO ldrsPSFSTAR::Store, cfg
self->ldrsIMGAREA::Store, cfg
cfg->SetInt, 'HALOALGO', self.haloAlgo
cfg->SetInt, 'EPOLALGO', self.epolAlgo
cfg->SetInt, 'NXY', self.nxy
END

PRO ldrsPSFSTAR::Load, cfg
self->ldrsIMGAREA::Load, cfg
self.haloAlgo = cfg->GetInt('HALOALGO')
self.epolAlgo = cfg->GetInt('EPOLALGO')
self.nxy = cfg->GetInt('NXY')
self->Update
END

PRO ldrsPSFSTAR__define
  struct = { ldrsPSFSTAR, $
             INHERITS ldrsIMGAREA, $
             haloAlgo:0, epolAlgo:0, nxy:0 $
           }
END
