PRO LDRS_TOOL_SELECT, event
WIDGET_CONTROL, event.id, GET_UVALUE=tool
IF NOT OBJ_VALID(tool) THEN RETURN
img = tool->GetView()
IF NOT OBJ_VALID(img) THEN RETURN
img->SelectTool, tool
END

FUNCTION ldrsTOOL::Init, view, cfg
self.view = view
self.tag = cfg->GetString('TAG')
self.label = cfg->GetString('LABEL')
self.className = cfg->GetString('CLASS')
nData = BYTARR(24,24)
sData = BYTARR(24,24)
sData[*,*] = 255
FOR y=0,23 DO BEGIN
    line = cfg->GetString(STRING(FORMAT='(A, I0)', 'BM', y + 1))
    x=0
    WHILE x NE -1 DO BEGIN
        x = STRPOS(line, '*', x)
        IF x NE -1 THEN BEGIN
            nData[x, 23 - y] = 255
            sData[x, 23 - y] = 0
            x += 1
        ENDIF
    ENDWHILE
ENDFOR
self.iconNormal = PTR_NEW(CVTTOBM(nData))
self.iconSelected = PTR_NEW(CVTTOBM(sData))
RETURN, 1
END

FUNCTION ldrsTOOL::GetView
RETURN, self.view
END

FUNCTION ldrsTOOL::GetImpl
IF NOT OBJ_VALID(self.impl) THEN self.impl = OBJ_NEW(self.className, self.view)
RETURN, self.impl
END

PRO ldrsTOOL::Select
WIDGET_CONTROL, self.guiBtn, SET_VALUE=*self.iconSelected
END

PRO ldrsTOOL::Deselect
WIDGET_CONTROL, self.guiBtn, SET_VALUE=*self.iconNormal
END

PRO ldrsTOOL::CreateGUI, base, cfgTool
self.guiBtn = WIDGET_BUTTON(base, VALUE=*self.iconNormal, UVALUE=self, EVENT_PRO='LDRS_TOOL_SELECT', TOOLTIP=self.label, SENSITIVE=1)
END

PRO ldrsTOOL__define
  struct = { ldrsTOOL, $
             view:OBJ_NEW(), $
             tag:'', $
             label:'', $
             className:'', $
             iconNormal:PTR_NEW(), $
             iconSelected:PTR_NEW(), $
             guiBtn:0, $
             impl:OBJ_NEW() $
           }
END
