FUNCTION ldrsTOOLIMPL::Init, view
IF NOT self->ldrsDIALOG::Init() THEN RETURN, 0
self.view = view
self.dlgTitle = 'Information'
RETURN, 1
END

PRO ldrsTOOLIMPL::CreateContent
self->ldrsDIALOG::CreateContent
END

PRO ldrsTOOLIMPL::CreateImageExtension, imgExt, file, nr
END

PRO ldrsTOOLIMPL::ImageExtensionDestroyed, imgExt, file, nr
END

PRO ldrsTOOLIMPL::DoEvent, event
self.top = event.top
CASE event.type OF
    0: CASE event.press OF
        1 : self->PressLeft, event.modifiers, event.x, event.y
        2 : self->PressMiddle, event.modifiers, event.x, event.y
        4 : self->PressRight, event.modifiers, event.x, event.y
        ELSE:
    ENDCASE
    1: CASE event.release OF
        1: self->ReleaseLeft, event.modifiers, event.x, event.y
        2: self->ReleaseMiddle, event.modifiers, event.x, event.y
        4: self->ReleaseRight, event.modifiers, event.x, event.y
        ELSE:
    ENDCASE
    2: self->Move, event.modifiers, event.x, event.y
ELSE:
ENDCASE
END

PRO ldrsTOOLIMPL::PressLeft, modifiers, x, y
END

PRO ldrsTOOLIMPL::PressMiddle, modifiers, x, y
END

PRO ldrsTOOLIMPL::PressRight, modifiers, x, y
END

PRO ldrsTOOLIMPL::ReleaseLeft, modifiers, x, y
END

PRO ldrsTOOLIMPL::ReleaseMiddle, modifiers, x, y
END

PRO ldrsTOOLIMPL::ReleaseRight, modifiers, x, y
END

PRO ldrsTOOLIMPL::Move, modifiers, x, y
END

PRO ldrsTOOLIMPL::Activate, view
self.view = view
END

PRO ldrsTOOLIMPL::ShowInfo, info
self.view->ShowInfo, info
END

PRO ldrsTOOLIMPL::Edit, top, obj
;PRINT, 'ldrsTOOLIMPL::Edit, ', top
self.infoObj = obj
self->CreateDialog, top
self->ReadStaticContent
self->ReadDynamicContent
self->ShowDialog
END

PRO ldrsTOOLIMPL::ObjectChanged, obj
IF self.dlgBase EQ 0 THEN RETURN
IF self.infoObj NE obj THEN RETURN
IF self.dlgVisible EQ 0 THEN RETURN
self->ReadDynamicContent
END

FUNCTION ldrsTOOLIMPL::GetView
RETURN, self.view
END

PRO ldrsTOOLIMPL__define
struct = { ldrsTOOLIMPL, $
           INHERITS ldrsDIALOG, $
           view:OBJ_NEW(), $
           top:0, $
           infoObj:OBJ_NEW() $
         }
END
